;******************************************************************************
;*
;*						3D General Routines
;*   24/07/95 11:11
;******************************************************************************

	.486

_DATA	SEGMENT PARA PUBLIC USE32 'DATA'

	EXTERNDEF C phd_mxptr:DWORD

_DATA	ENDS

;******************************************************************************

DGROUP	GROUP _DATA

_TEXT	SEGMENT PARA PUBLIC USE32 'CODE'

	ASSUME cs:_TEXT
	ASSUME ds:_DATA

;*****************************  Defines ***************************************

W2V_SCALE	equ		16384
M00			equ		0
M01			equ		4
M02			equ		8
M03			equ		12
M10			equ		16
M11			equ		20
M12			equ		24
M13			equ		28
M20			equ		32
M21			equ		36
M22			equ		40
M23			equ		44

;***************************************************************************
;*				Push Matrix Routine
;****************************************************************************
_phd_PushMatrix	PROC PUBLIC
		push	esi
		push	edi
		push	ecx
		cld         				; Clear Direction Of Copy
		mov		esi,[phd_mxptr]
		mov		ecx,12
		lea		edi,[esi+ecx*4]		; Copy Current Matrix Into
		rep		movsd               ; Next Matrix Slot
		mov		[phd_mxptr],esi     ; Increment Matrix Ptr
		pop		ecx
		pop		edi
		pop		esi
		ret
_phd_PushMatrix	ENDP

;***************************************************************************
;*				(Push Unit Matrix) AND (Unit Matrix)
;****************************************************************************
_phd_PushUnitMatrix	PROC PUBLIC
		add		DWORD PTR[phd_mxptr],48
_phd_PushUnitMatrix	ENDP

_phd_UnitMatrix PROC PUBLIC
		push	edi
		push	eax
		mov		edi,[phd_mxptr]
		mov		eax,W2V_SCALE
		mov		[edi+M00],eax
		mov		[edi+M11],eax
		mov		[edi+M22],eax
		xor		eax,eax
		mov		[edi+M01],eax
		mov		[edi+M02],eax
		mov		[edi+M10],eax
		mov		[edi+M12],eax
		mov		[edi+M20],eax
		mov		[edi+M21],eax
		pop		eax
		pop		edi
		ret
_phd_UnitMatrix ENDP

;******************************************************************************
_TEXT	ENDS
	END
