/****************************************************************************
*
* DEMO.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 03/06/98
*   MODIFIED : 03/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for DEMO.C
*
*****************************************************************************/

#ifndef _DEMO_H
#define _DEMO_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "text.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

#define DEMOCOUNT_MAX ((30*60*2)+8)	// 1 minute

//#define DEMOCOUNT_MAX (30*60*5)			// 5 Minutes Max of Demo..
#define RANDOM_SEED 0xd371f947

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern int DemoPlay;
extern uint32 *demoptr;
extern int democount;
extern int demo_loaded;

extern sint32 DoDemoSequence( int level_number );

extern sint32 StartDemo(int demo_level);
extern void LoadLaraDemoPos();
extern void SaveLaraDemoPos();
extern void DemoGameLoop();
extern int ControlPhaseDemo(sint32 nframes);
extern void GetDemoInput();
extern sint32 StartSaveDemo(int level);
extern void SaveDemoData();

#ifdef PSX_VERSION
extern TEXTSTRING *demotxt;
#endif

#ifdef __cplusplus
}
#endif

#endif
