/**************************************************************************************/
/*                                                                                    */
/* Available object types: this file is used by room, anim and sprite editors         */
/*                                                                                    */
/**************************************************************************************/

/* Version number MUST be increased whenever the object lists are changed */
#define OBJECT_VERSION 45

enum object_types {
	LARA, PISTOLS, HAIR, SHOTGUN, MAGNUM, UZI, M16, ROCKET_GUN, HARPOON_GUN, FLARE, SKIDOO_ANIM, BOAT_ANIM, LARA_EXTRA,
	SKIDOO, MOTORBOAT,
	DOG, CULT1, CULT1B, CULT1C, CULT2, CULT3, SMALL_RAT, DRAGON_FRONT, DRAGON_BACK, GONDOLA,
	SHARK, EEL, BIG_EEL, BARACUDDA, DIVER, WORKER1, WORKER2, WORKER3, WORKER3B, WORKER4, JELLY_FISH,
	SPIDER, BIG_SPIDER, CROW, TIGER, EMPEROR, CHINESE1, CHINESE2, CHINESE3, CHINESE4,
	YETI, BIG_YETI, EAGLE, BANDIT1, BANDIT2, BANDIT2B, BANDIT3, SKIDMAN, MONK1, MONK2,
	FALLING_BLOCK, FALLING_BLOCK2, FALLING_PLANK,
	PENDULUM, SPIKES, ROLLING_BALL, DARTS, DART_EMITTER, DRAW_BRIDGE, TEETH_TRAP, LIFT,
	MOVING_BAR, MOVABLE_BLOCK, MOVABLE_BLOCK2, MOVABLE_BLOCK3, MOVABLE_BLOCK4, BIG_BOWL,
	SMASH_WINDOW, SMASH_ICE, SMASH_WIN2, SMASH_WIN3, PROPELLER, SAW, HOOK,
	FALLING_CEILING1, SPINNING_BLADE,
	BLADE, KILLER_STATUE, AVALANCHE, ICICLES, SPIKE_WALL, SPRING_BOARD, CEILING_SPIKES,
	BELL, WATER_SPRITE, SNOW_SPRITE, SKID_TRACK, AIRLOCK_SWITCH, SMALL_SWITCH,
	FAN, SMALL_FAN, SWING_BOX, MESHSWAP1, MESHSWAP2, MESHSWAP3, BORDERS, OILDRUMS, DEATH_SLIDE, PUSH_SWITCH, 
	SWITCH_TYPE1, SWITCH_TYPE2,
	DOOR_TYPE1, DOOR_TYPE2, DOOR_TYPE3, DOOR_TYPE4, DOOR_TYPE5, DOOR_TYPE6, DOOR_TYPE7, DOOR_TYPE8,
	TRAPDOOR, TRAPDOOR2, BIGTRAPDOOR,
	BRIDGE_FLAT, BRIDGE_TILT1, BRIDGE_TILT2,
	PASSPORT_OPTION, MAP_OPTION, PHOTO_OPTION,
	PLAYER_1, PLAYER_2, PLAYER_3, PLAYER4, PLAYER_5, PLAYER_6, PLAYER_7, PLAYER_8, PLAYER_9, PLAYER_10,
	PASSPORT_CLOSED, MAP_CLOSED,
	GUN_ITEM, SHOTGUN_ITEM, MAGNUM_ITEM, UZI_ITEM, HARPOON_ITEM, M16_ITEM, ROCKET_GUN_ITEM,
	GUN_AMMO_ITEM, SG_AMMO_ITEM, MAG_AMMO_ITEM, UZI_AMMO_ITEM, HARPOON_AMMO_ITEM, M16_AMMO_ITEM, ROCKET_AMMO_ITEM,
	MEDI_ITEM, BIGMEDI_ITEM, FLAREBOX_ITEM, FLARE_ITEM,
	DETAIL_OPTION, SOUND_OPTION, CONTROL_OPTION, GAMMA_OPTION,
	GUN_OPTION, SHOTGUN_OPTION, MAGNUM_OPTION, UZI_OPTION, HARPOON_OPTION, M16_OPTION, ROCKET_OPTION,
	GUN_AMMO_OPTION, SG_AMMO_OPTION, MAG_AMMO_OPTION, UZI_AMMO_OPTION, HARPOON_AMMO_OPTION, M16_AMMO_OPTION, ROCKET_AMMO_OPTION,
	MEDI_OPTION, BIGMEDI_OPTION, FLAREBOX_OPTION,
	PUZZLE_ITEM1, PUZZLE_ITEM2, PUZZLE_ITEM3, PUZZLE_ITEM4,
	PUZZLE_OPTION1, PUZZLE_OPTION2, PUZZLE_OPTION3, PUZZLE_OPTION4,
	PUZZLE_HOLE1, PUZZLE_HOLE2, PUZZLE_HOLE3, PUZZLE_HOLE4,
	PUZZLE_DONE1, PUZZLE_DONE2, PUZZLE_DONE3, PUZZLE_DONE4,
	SECRET_ITEM1, SECRET_ITEM2, SECRET_ITEM3,	
	KEY_ITEM1, KEY_ITEM2, KEY_ITEM3, KEY_ITEM4,
	KEY_OPTION1, KEY_OPTION2, KEY_OPTION3, KEY_OPTION4,
	KEY_HOLE1, KEY_HOLE2, KEY_HOLE3, KEY_HOLE4,
	PICKUP_ITEM1, PICKUP_ITEM2,
	PICKUP_OPTION1, PICKUP_OPTION2,
	SPHERE_OF_DOOM, SPHERE_OF_DOOM2, SPHERE_OF_DOOM3,
	ALARM_SOUND, WATER_DRIP, DINOSAUR, BIRD_TWEETER, CLOCK_CHIMES, LIGHTNING_EMITTER, 
	DEAD_DRAGON_FRONT, DEAD_DRAGON_BACK, HOT_LIQUID,
	BOAT_BITS, MINES, MENU_BACKGROUND, SHADOW,
	GONGBONGER, GONG, DETONATOR, COPTER,
	EXPLOSION1,	SPLASH1, BUBBLES1, BUBBLES2, BLOOD1, DART_EFFECT,
	FLARELIGHT, GLOW, MAP_GLOW,
	RICOCHET1, TWINKLE, GUN_FLASH, M16_FLASH, BODY_PART, CAMERA_TARGET,
	WATERFALL, DIVER_HARPOON, DRAGON_FIRE, KNIFE, ROCKET, HARPOON_BOLT,
	LAVA, LAVA_EMITTER,
	FLAME, FLAME_EMITTER,
	HORIZON, 
	ALPHABET,
	DYING_MONK, DING_DONG, LARA_ALARM, MINI_COPTER, WINSTON, ASSAULT_NUMBERS, FINAL_LEVEL, CUT_SHOTGUN, EARTHQUAKE,
	NUMBER_OBJECTS
};

enum static_types {
	PLANT0, PLANT1, PLANT2, PLANT3, PLANT4, PLANT5, PLANT6, PLANT7, PLANT8, PLANT9,
	FURNITURE0, FURNITURE1, FURNITURE2, FURNITURE3, FURNITURE4,
	FURNITURE5, FURNITURE6, FURNITURE7, FURNITURE8, FURNITURE9,
	ROCK0, ROCK1, ROCK2, ROCK3, ROCK4, ROCK5, ROCK6, ROCK7, ROCK8, ROCK9,
	ARCHITECTURE0, ARCHITECTURE1, ARCHITECTURE2, ARCHITECTURE3, ARCHITECTURE4,
	ARCHITECTURE5, ARCHITECTURE6, ARCHITECTURE7, ARCHITECTURE8, ARCHITECTURE9,
	DEBRIS0, DEBRIS1, DEBRIS2, DEBRIS3, DEBRIS4, DEBRIS5, DEBRIS6, DEBRIS7, DEBRIS8, DEBRIS9,
	NUMBER_STATIC_OBJECTS
};

enum floor_types {
	FLOOR_TYPE, DOOR_TYPE, TILT_TYPE, ROOF_TYPE, TRIGGER_TYPE, LAVA_TYPE, CLIMB_TYPE
};

enum trigger_types {
	TRIGGER, PAD, SWITCH, KEY, PICKUP, HEAVY, ANTIPAD, COMBAT, DUMMY, ANTITRIGGER
};

enum trigobj_types {
	TO_OBJECT, TO_CAMERA, TO_SINK, TO_FLIPMAP, TO_FLIPON, TO_FLIPOFF, TO_TARGET, TO_FINISH, TO_CD, TO_FLIPEFFECT, TO_SECRET, TO_BODYBAG
};
