#include "game.h"


/* General Game Info Variables (No. of levels, etc) */
GAMEFLOW_INFO gameflow;

/* TODO:
	Program to convert a readable script into this data

	LevelComplete quickkey - DEMO
	No.of secrets
	CD track for each level
	Cutscene CD tracks
	Camera pos/angles for cutscenes
	Sunset enable for certain levels
	Demo playback, which have built-in demos. User record?
	Key/Puzzle/Pickup names for each level
	Weapon names?
	Take all weapons from Lara on certain levels (see ModifyStartInfo() in savegame.c)
	Loading pics filenames for levels

	Other languages


SEQUENCE FOR TOMB II

	FRONTEND	- EidosPIC/CoreLogoFMV/EscapeFMV
	FMV - Intro - Great Wall Ancient Time

	TITLE PAGE	- 

	FMV-1		- Great Wall Present Time
	LEVEL 1		- WALL 'The Great Wall'
	CUT-1		- Cult Camp / Great Wall
	LEVELSTATS

	LEVEL 2		- BOAT Venice Canals

	LEVEL 3		- VENICE  (Bartoli's House) 
	LEVELSTATS

	LEVEL 4		- OPERA House, Venice
	CUT-2		- CargoHold SeaPlane - Venice
	LEVELSTATS

	FMV-2		- Rig/Ocean
	LEVEL 5		- RIG /Ship
	CUT-3		- Rig/Changing Area
	LEVELSTATS

	LEVEL 6		- UNWATER Underwater (Diving Pool/Rig)
	LEVELSTATS

	FMV-3		- Mini Sub - grabs onto sub until crash
	LEVEL 7		- KEEL Sunken Ship
	LEVELSTATS

	LEVEL 8		- LIVING Sunken Ship
	LEVELSTATS

	LEVEL 9		- DOCK Sunken Ship
	LEVELSTATS	

	FMV-4		- SeaPlane Taking off & crash onto tibet mountain
	LEVEL 10		- SKIDOO
	LEVELSTATS	

	LEVEL 11	- MONASTRY
	LEVELSTATS	

	LEVEL 12	- CATACOMB
	LEVELSTATS	

	LEVEL 13	- ICECAVE
	LEVELSTATS	

	FMV-5		- Mountain Side Tibet, Jeep ride to Great Wall
	LEVEL 14	- EMPRTOMB - Emporer's Tomb
	LEVELSTATS	

	CUT-4		- Cult ritual

	LEVEL 15	- FLOATING
	LEVELSTATS
	FMV-6		- End Sequence?
	
	LEVEL 16	- HOUSE
*/

/**************************************************************/
/*	I F   U S I N G   S C R I P T									  */
/**************************************************************/

extern char GF_Description[256]={0};


/*   Sequence Pointers    */
sint16 *GF_frontendSequence;
sint16 *GF_level_sequence_list[MAXIMUM_LEVELS];
sint16 *GF_demo_sequence_list[MAX_DEMO_FILES];


/*   Strings Buffers      */
char *GF_levelnames_buffer;
char *GF_GameStrings_buffer;
#ifdef PC_VERSION
char *GF_PCStrings_buffer;
#else
char *GF_PSXStrings_buffer;
#endif
char *GF_Puzzle1Strings_buffer;
char *GF_Puzzle2Strings_buffer;
char *GF_Puzzle3Strings_buffer;
char *GF_Puzzle4Strings_buffer;
char *GF_Secret1Strings_buffer;
char *GF_Secret2Strings_buffer;
char *GF_Secret3Strings_buffer;
char *GF_Secret4Strings_buffer;
char *GF_Special1Strings_buffer;
char *GF_Special2Strings_buffer;
char *GF_Pickup1Strings_buffer;
char *GF_Pickup2Strings_buffer;
char *GF_Key1Strings_buffer;
char *GF_Key2Strings_buffer;
char *GF_Key3Strings_buffer;
char *GF_Key4Strings_buffer;

/* Filaname buffers */
char *GF_picfilenames_buffer;  
char *GF_titlefilenames_buffer; 
char *GF_fmvfilenames_buffer;   
char *GF_levelfilenames_buffer; 
char *GF_cutscenefilenames_buffer;
char *GF_demofilenames_buffer;  
sint16 *GF_sequence_buffer;


/* String ptr lists */
char **GF_Level_Names;
char **GF_GameStrings;
#ifdef PC_VERSION
char **GF_PCStrings;
#else
char **GF_PSXStrings;
#endif
char **GF_Puzzle1Strings;
char **GF_Puzzle2Strings;
char **GF_Puzzle3Strings;
char **GF_Puzzle4Strings;
char **GF_Secret1Strings;
char **GF_Secret2Strings;
char **GF_Secret3Strings;
char **GF_Secret4Strings;
char **GF_Special1Strings;
char **GF_Special2Strings;
char **GF_Pickup1Strings;
char **GF_Pickup2Strings;
char **GF_Key1Strings;
char **GF_Key2Strings;
char **GF_Key3Strings;
char **GF_Key4Strings;

/* Filename ptr lists */
char **GF_picfilenames;
char **GF_titlefilenames;
char **GF_fmvfilenames;
char **GF_levelfilenames;
char **GF_cutscenefilenames;
char **GF_demofilenames;



#ifdef PSX_VERSION
/********** START OF PSX SPECIFIC BITS *****************/

FMV_INFO	GF_fmv_data[MAX_FMV_FILES]=	{0};
/********** END OF PSX SPECIFIC BITS *****************/
#endif

sint16	GF_valid_demos[MAX_DEMO_FILES];

char *GF_inv_types[]={
	"PISTOLS",
	"SHOTGUN",
	"AUTOPISTOLS",
	"UZIS",
	"HARPOON",
	"M16",
	"ROCKETLAUNCHER",

	"PISTOL_AMMO",
	"SHOTGUN_AMMO",
	"AUTOPISTOLS_AMMO",
	"UZI_AMMO",
	"HARPOON_AMMO",
	"M16_AMMO",
	"ROCKETLAUNCHER_AMMO",
	"FLARES",

	"MEDI",
	"BIGMEDI",

	"PICKUP1",
	"PICKUP2",
	"PUZZLE1",
	"PUZZLE2",
	"PUZZLE3",
	"PUZZLE4",
	"KEY1",
	"KEY2",
	"KEY3",
	"KEY4"
};

// TODO: Credits pics/files
