/****************************************************************************
*
* SETUP.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 02/06/98
*   MODIFIED : 02/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for SETUP.C
*
*****************************************************************************/

#ifndef _SETUP_H
#define _SETUP_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#include "../spec_psx/3d_gen.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern int monks_attack_lara;

extern int InitialiseLevel(int level_number, int type);
extern void InitialiseLevelFlags();
extern void InitialiseObjects();
extern void GetCarriedItems();
extern void GetAIPickups();

extern void BuildOutsideTable();

typedef struct
{
	sint16 	attack_count;
	sint16 	death_count;
	uint8 	attack_flag;
	uint8 	attack_type;
	uint8 	attack_head_count;
	uint8 	ring_count;
	sint16 	explode_count;
	sint16 	LizmanItem,LizmanRoom;
	sint16 	hp_counter;
	sint16 	dropped_icon;
	uint8 	charged;
	uint8 	dead;
	PHD_VECTOR	BeamTarget;
} BOSS_STRUCT;

extern BOSS_STRUCT	bossdata;

#ifdef __cplusplus
}
#endif

#endif

