/****************************************************************************
*
* SNOW.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 02/07/98
*   MODIFIED : 02/07/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for SNOW.C
*
*****************************************************************************/

#ifndef _SNOW_H
#define _SNOW_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "..\spec_psx\typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

#define MAX_SNOWFLAKES	256

/*---------------------------------------------------------------------------
 *	Type Definitions
\*--------------------------------------------------------------------------*/

typedef struct {
	long		x;
	long		old_roomflags:1;
	long		stopped:1;
	long		y:30;
	long		z;

	signed	char	xv;
	unsigned	char yv;	// Also determines size of flake.
	signed	char zv;
	unsigned	char life;
} SNOWFLAKE;

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

#ifndef DoRain
#define DoRain()					\
	if (WeatherPtr != NULL)			\
		((VOIDFUNCVOID *)WeatherPtr)()
#endif

#else

extern void DoSnow();

#endif

#ifdef __cplusplus
}
#endif

#endif
