/****************************************************************************
*
* BIGGUN.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 22/09/98
*   MODIFIED : 22/09/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for BIGGUN.C
*
*****************************************************************************/

#ifndef _BIGGUN_H
#define _BIGGUN_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "../specific/stypes.h"
#include "../3dsystem/3d_gen.h"
#endif

#include "items.h"
#include "collide.h"

/*---------------------------------------------------------------------------
 *	Type Definitions
\*--------------------------------------------------------------------------*/

typedef struct {
	sint16 RotX;
	sint16 RotY;
	sint16 StartRotY;
	char Flags;
	signed char FireCount;
}BIGGUNINFO;

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if !defined(BIGGUNINFO_ONLY)

#if defined(PSX_VERSION) && defined(RELOC)

typedef int  (BIGGUNFUNC1)(COLL_INFO *);
typedef void (BIGGUNFUNC2)(sint16, ITEM_INFO *, COLL_INFO *);
typedef void (BIGGUNFUNC3)(ITEM_INFO *);

#define BigGunInitialise	((VOIDFUNCSINT16 *)VehiclePtr[0])
#define BigGunControl 	((BIGGUNFUNC1 *)VehiclePtr[1])
#define BigGunCollision	((BIGGUNFUNC2 *)VehiclePtr[2])
#define BigGunDraw		((BIGGUNFUNC3 *)VehiclePtr[3])

#else

extern void BigGunInitialise(sint16 item_number);
extern int  BigGunControl(COLL_INFO *coll);
extern void BigGunCollision(sint16 item_number, ITEM_INFO *litem, COLL_INFO *coll);
extern void BigGunDraw(ITEM_INFO *v);

#endif

#endif

#ifdef __cplusplus
}
#endif

#endif
