/****************************************************************************
*
* MEMCARD.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 25/05/98
*   MODIFIED : 25/05/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for MEMCARD.C
*
*****************************************************************************/

#ifndef _MEMCARD_H
#define _MEMCARD_H

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#include "..\game\savegame.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

#define MEMCARD

enum	{
	MCF_NONE,
	MCF_LOADED,
	MCF_CAN_SAVE,
	MCF_SAVED,
	MCF_FAILED
};

/*---------------------------------------------------------------------------
 *	Type Definitions
\*--------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern char GabMemoryCardHeader[];

#ifdef MEMCARD
extern int S_MemoryCardOperation(int nOperation,void *pData,int nBytes);
extern int S_LoadGame(SAVEGAME_INFO *pData, int nBytes, int level);
extern int S_SaveGame(SAVEGAME_INFO *pData,int nBytes,int ingame);
extern int S_FrontEndCheck(SAVEGAME_INFO *pData,int nBytes);
#else
#define S_MemoryCardOperation(a, b, c) 0
#define S_LoadGame(a, b, c) 0
#define S_SaveGame(a, b, c) 0
#define S_FrontEndCheck(a, b) 0
#endif

#endif
