;****************************************************************************
;
; ROOM.INC
;
; PROGRAMMER : Chris
;    VERSION : 00.00
;    CREATED : 20/02/98
;   MODIFIED : 20/02/98
;       TABS : 8 9 8
;
; DESCRIPTION
;	Room equates & definitions
;
;****************************************************************************

;----------------------------------------------------------------------------
; Constants
;----------------------------------------------------------------------------

; -------- Room flags

UNDERWATER	equ	1
SFX_ALWAYS	equ	2
PITCH_SHIFT	equ	4
OUTSIDE		equ	8
DYNAMIC_LIT	equ	16
NOT_INSIDE	equ	32
INSIDE		equ	64
SWAMP		equ	128

;----------------------------------------------------------------------------
; Type Definitions
;----------------------------------------------------------------------------

; -------- ROOM_INFO structure

		rsreset
riData		rw	1	; ptr to meshes
riDoor		rw	1	; ptr to doors
riFloor		rw	1	; ptr to floor
riLight		rw	1	; ptr to lights
riMesh		rw	1	; ptr to triggers
riX		rw	1	; world position
riY		rw	1
riZ		rw	1
riMinFloor	rw	1	; y space
riMaxCeiling	rw	1
riWidth		rh	1	; floor dimensions
riHeight	rh	1
riAmbientA	rh	1	; lighting data
riLighting	rh	1
riNumLights	rh	1
riReverbType	rh	1
riNumMeshes	rh	1
riMeshEffect	rb	1
riBoundActive	rb	1	; clip window construction data
riClipL		rh	1	; clip window
riClipR		rh	1
riClipT		rh	1
riClipB		rh	1
riTestL		rh	1
riTestR		rh	1
riTestT		rh	1
riTestB		rh	1
riItemNum	rh	1
riFXNum		rh	1
riFlippedRoom	rh	1
riFlags		rh	1
ROOM_INFO	rb	0

; -------- LIGHT_INFO structure

		rsreset
rlX		rw	1
rlY		rw	1
rlZ		rw	1
rlR		rb	1
rlG		rb	1
rlB		rb	1
rlType		rb	1
		rsset	rlType
rlNx		rh	1
rlNy		rh	1
rlNz		rh	1
rlPad		rh	1
		rsset	rlType
rlIntensity	rw	1
rlFalloff	rw	1
ROOM_LIGHT_INFO	rb	0

