/****************************************************************************
*
* SPUSOUND.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 05/06/98
*   MODIFIED : 05/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for SPUSOUND.C
*
*****************************************************************************/

#ifndef _SPUSOUND_H
#define _SPUSOUND_H

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#include <sys\types.h>
#include <libspu.h>
#include "typedefs.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

#define MAX_VAG_SAMPLES 256
#define MAX_SPU_MALLOCS 1

#define SPU_ERR_SOUND_FAILED		 (-2)
#define SPU_ERR_SOUND_NO_FREE_SLOTS (-1)

#define ERR_SOUND_NOT_ENABLED		(-3)
#define ERR_SOUND_FAILED			(-2)
#define ERR_SOUND_NO_FREE_SLOTS	(-1)

enum	{
	SPU_SAMPLETYPE_OFF,
	SPU_SAMPLETYPE_NORMAL,
	SPU_SAMPLETYPE_LOOPED
};

#define HZ_11000	0x400
#define HZ_9500	0x370
#define HZ_8000	0x2e8
//#define SAMPLE_RATE	HZ_8000
#define SAMPLE_RATE	HZ_11000

/*---------------------------------------------------------------------------
 *	Macros
\*--------------------------------------------------------------------------*/

#define SPU_AdjustPitch(c, p)	SpuSetVoicePitch((c), (SAMPLE_RATE*(p)) >> 16);

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern int SPU_Play(int nSample,int nLeftVolume,int nRightVolume,int nPitch,int nSampleType);
extern void SPU_AdjustVolume(int nChannel,int nLeftVolume,int nRightVolume);
extern void SPU_Stop(int nChannel);
extern void SPU_StopAll();
extern void SPU_Pause(int nChannel);
extern void SPU_PauseAll();
extern void SPU_Unpause(int nChannel);
extern void SPU_UnpauseAll();
extern int SPU_Status(int nChannel);
extern int SPU_UpdateStatus();
extern int SPU_LoadSamples(int nSamples,uint32* padwOffset,void* pVAB,int nVABSize);
extern void SPU_FreeSamples();
extern void SPU_Init();
extern void SPU_Cleanup();

#endif
